// $Id: dropdown.js,v 1.1.2.2 2007/06/03 10:34:32 stborchert Exp $

/**
 *
 * @access public
 * @return void
 **/
function _createDropdown(obj){
  var dropdown;
  var elemname;
  try {
    elemname = $(obj).parent().attr('id');
    _removeDescendant($(obj));
  }
  catch (e) {
    elemname = 'browse_sel_-1';
  }

  var level = parseInt(elemname.substring(elemname.lastIndexOf("_") + 1, elemname.length)) + 1;

  var elemBase = elemname.substring(0, elemname.lastIndexOf("_") + 1);

  // create surrounding <div>
  var sel_div = $('<div></div>');
  $(sel_div).attr('name', elemBase + level);
  $(sel_div).attr('id', elemBase + level);
  $(sel_div).attr('style', 'display: block; margin: 1px 0; padding: 0; border: 0;');

  // create <select>
  var select = $('<select></select>');
  $(select).attr('size', 1);
  $(select).attr('name', elemBase + level + '_sel');
  $(select).attr('id', elemBase + level + '_sel');

  // add event handler
  $(select).change(function() {
    _removeDescendant($(this).parent());
    _clearNodeList();
    loadCategories($(this));
  });

  // create image (only if level > 0)
  if (level > 0) {
    var img = $('<img />');
    $(img).attr('id', elemname.substring(0, elemname.lastIndexOf('_') + 1) + level + '_img');
    $(img).attr('alt', '');
    $(img).attr('src', 'images/descendant.gif');
    // extra margin for IE
    $(img).css({margin: '0px 2px', border: 0});
    $(img).css({marginLeft: String((parseInt(level) - 1) * 14) + 'px', marginRight: '2px'});
    $(sel_div).append($(img));
  }

  $(sel_div).append($(select));
  $(sel_div).hide();
  $('#form_browse').append($(sel_div));
  $(sel_div).show('slow');
  return select;
}

/**
 * _fillDropdown
 * @return true if a dropdown was inserted
 **/
function _fillDropdown(obj, results){
  if (results.menus != false) {
    var select = _createDropdown(obj);
    $(select).addOption(-1, tinyMCELang['lang_linktomenu_choose_category']);
    for (key in results.menus) {
      if (results.menus[key].hasChildren) {
        $(select).addOption(results.menus[key].mid, results.menus[key].title);
      }
    }
    return true;
  }
  return false;
}

/**
* remove "child" elements
**/
function _removeDescendant(elem) {
  if (elem == null)
    return;
  $(elem).next().each(
    function() {
      _removeDescendant($(this));
      window.resizeBy(0, -17);
      $(this).hide('slow').remove();
    }
  );
}
