// $Id: options.js,v 1.1.2.2 2007/02/14 21:58:06 stborchert Exp $

$.fn.addOption = function()
{
	if(arguments.length == 0)
    return this;
	// select option when added? default is false
	var selectOption = false;
	// multiple items
	var multiple = false;
	if(typeof arguments[0] == "object")
	{
		multiple = true;
		var items = arguments[0];
	}
	if(arguments.length >= 2)
	{
		if(typeof arguments[1] == "boolean")
      selectOption = arguments[1];
		else if(typeof arguments[2] == "boolean")
      selectOption = arguments[2];
    if(!multiple)
		{
			var value = arguments[0];
			var text = arguments[1];
		}
	}
	this.each(
		function()
		{
			if(this.nodeName.toLowerCase() != "select")
        return;
			if(multiple)
			{
				for(v in items)
				{
					$(this).addOption(v, items[v], selectOption);
				}
			}
			else
			{
				var option = document.createElement("option");
				option.value = value;
				option.text = text;
				this.options.add(option);
			}
			if(selectOption)
			{
				this.options[this.options.length-1].selected = true;
			}
		}
	)
	return this;
}

$.fn.removeOption = function()
{
	if(arguments.length == 0)
    return this;
	if(typeof arguments[0] == "string")
    var value = arguments[0];
	else if(typeof arguments[0] == "number")
    var index = arguments[0];
	else
    return this;
	this.each(
		function()
		{
			if(this.nodeName.toLowerCase() != "select")
        return;
			if(value)
			{
				var optionsLength = this.options.length;
				for(var i=optionsLength-1; i>=0; i--)
				{
					if(this.options[i].value == value)
					{
						this.options[i] = null;
					}
				}
			}
			else
			{
				this.remove(index);
			}
		}
	)
	return this;
}
